/***************************************************************************
                               kmudfactory.h
                             -------------------
    begin                : Fri Apr 6 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMUDFACTORY_H
#define KMUDFACTORY_H

#include <klibloader.h>
#include <kservice.h>

class KmudAPI;
class KmudPart;


/**
	* Base class for all part factories. You have to implement createKmudPartObject().
  *@author Kmud Developer Team
  */

class KmudFactory : public KLibFactory  {
public: 
	KmudFactory(QObject* parent, const char* name);
	virtual ~KmudFactory();

	KmudPart* createKmudPart(KmudAPI* api, QObject* parent, KService::Ptr service, const QStringList& args=QStringList());

protected:
	virtual KmudPart* createKmudPartObject(KmudAPI* api, QObject* parent, const QStringList& args) = 0;

private:
	virtual QObject* createObject(QObject* parent=0, const char* name=0, const char* classname="QObject", const QStringList &args=QStringList() );
	
};

#endif
