/***************************************************************************
                               kmudmapperpart.h
                             -------------------
    begin                : Sat Apr 28 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMUDMAPPERPART_H
#define KMUDMAPPERPART_H

#include "kmudpart.h"

#include <kmuddockwidget.h>

/**
  *@author Kmud Developer Team
  */
//TODO_jp : remove nt
class KmudMapperPart : public KmudPart
{
Q_OBJECT
public: 
	KmudMapperPart();
	virtual ~KmudMapperPart();

	/** This method is called when a new map needs to be created */
	virtual void createNewMap()=0;
	/** This method is used to create a test map. It is used for debuggin the mapper */
	virtual void generateTestMap()=0;
	/** This method is called to open a new map view
      * @return A pointer to the map view dockwidget */
	virtual KmudDockWidget* openMapView()=0;

public slots:
	/** Used to abort a speedwalk that is in progress */
	virtual void slotAbortSpeedwalk(void)=0;

signals:

	/** This is emited when a speedwalk operation is started
      * @param totalSteps The total number of steps in the walk operation
      */
	void startSpeedwalk(int totalSteps);
	/** This is emited when the speedwalk finishes */
	void endSpeedwalk();
};

#endif
